#pragma once
//Direct Show includes
#include <streams.h>

// Meraka includes
#include <MultiIOBaseFilter.h>



//GUID
// {271DBD03-CBB6-44f0-B36C-3EED2FD57FFE}
static const GUID CLS_STREAM_CONCAT = 
{ 0x271dbd03, 0xcbb6, 0x44f0, { 0xb3, 0x6c, 0x3e, 0xed, 0x2f, 0xd5, 0x7f, 0xfe } };


class CStreamConcatFilter : public virtual CMultiIOBaseFilter
{
public:
	/// Constructor
	CStreamConcatFilter();
	/// Virtual Destructor
	virtual ~CStreamConcatFilter();

	/// Static object-creation method (for the class factory)
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr); 

	virtual HRESULT Receive(IMediaSample *pSample, int nIndex );
	
	virtual int InitialNumberOfInputPins();
	virtual int InitialNumberOfOutputPins();
	virtual bool OnFullCreateMoreInputs();
	virtual bool OnFullCreateMoreOutputs();
	virtual void InitialiseInputTypes();
	virtual void InitialiseOutputTypes();

	/// From CBaseOutputPin
	virtual HRESULT DecideBufferSize(IMemAllocator* pAlloc, ALLOCATOR_PROPERTIES* pRequestProperties, int m_nIndex);

	/// To Check media type
	virtual HRESULT GetMediaType(int iPosition, CMediaType* pmt, int nOutputPinIndex) ;

protected:

private:
	BYTE* m_pBuffers[2];
	long m_nSizes[2];
};